﻿package 
{
	import flash.display.Sprite;
	import flash.display.StageDisplayState;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Graph extends Sprite
	{
		private var limit:Number = 700;
		private var counter:Number = 0;
		
		public function Graph()
		{
			addEventListener(Event.ADDED_TO_STAGE,added_handle);	
		}
		
		public function added_handle(e:Event):void
		{
			drawStage(stage.stageWidth,stage.stageHeight);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, added_handler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
		}
		
		public function added_handler(e:Event):void
		{
			drawStage(stage.stageWidth,stage.stageHeight);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, double_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP, remove_handler);
			stage.doubleClickEnabled=true;
			stage.addEventListener(MouseEvent.DOUBLE_CLICK, full);

		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			drawStage(stage.stageWidth,stage.stageHeight);
			eraseAll();
		}
		
		private function remove_handler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, double_handler)
			}
		private function double_handler(e:MouseEvent):void
		{
			if(counter>limit){
				eraseAll();
			}
			var boule:Point = new Point(stage.stageWidth,stage.stageHeight);
			addChild(boule);
			counter++;
		}
		
		private function eraseAll():void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			counter = 1;
		}
		
		private function full(e:MouseEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			counter = 1;
		}
		
		private function drawStage(stageWidth:Number,stageHeight:Number):void
		{	
			/*graphics.lineStyle(1,0xff0000,.4);
			graphics.moveTo(stageWidth/2,0);
			graphics.lineTo(stageWidth/2,stageHeight);
			graphics.moveTo(0,stageHeight/2);
			graphics.lineTo(stageWidth,stageHeight/2);*/
		}
		
	}
}
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Stage;
	import flash.display.BitmapData;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
class Point extends Sprite
{
	private var angle:Number=0;
	private var r1:Number;
	private var r2:Number; 
	private var orientation:Number;
	private var sW:Number;
	private var sH:Number;
	private var SCALE_MIN:Number=0.4;// the scale of the image at the back
	private var SCALE_MAX:Number=1;
	private var prevX:int=0;
	private var prevY:int=0;
	private var curX:int=0;
	private var curY:int=0;
	private var dx:Number;
	private var dy:Number;
	private var dist:Number=0;
	
	
	public function Point(stageWidth:Number,stageHeight:Number):void
	{
		r1 = (Math.random()*2)*7;
		r2 = (Math.random()*2)*7;
		sW = stageWidth;
		sH = stageHeight;
		orientation = Math.round(1-Math.random()*2);
		if(orientation == 0){orientation++;}
		graphics.beginFill(0xffffff,.4);
		graphics.drawCircle(mouseX-300,mouseY-300,4);
		graphics.endFill();
		addEventListener(Event.ENTER_FRAME, onEnterFrame);
		addEventListener(Event.REMOVED, removedHandler);
	}
	private function removedHandler(e:Event):void
	{
		e.currentTarget.removeEventListener(Event.ENTER_FRAME,onEnterFrame);
	}
	private function onEnterFrame(e:Event):void
	{
		angle+=4;
		this.x=stage.stageWidth/2+Math.cos(angle*Math.PI/180)*r1;
		this.y=stage.stageHeight/2-Math.sin(angle*Math.PI/180)*r2*orientation;
		this.scaleX = this.scaleY = (SCALE_MAX + SCALE_MIN )/2 + (SCALE_MAX - SCALE_MIN)/2 * Math.cos((angle%360)/180*orientation);
	}
}